/*Copyright (c) ${date} IBM Corporation and others.
All rights reserved. This program and the accompanying materials
are made available under the terms of the Eclipse Public License v1.0
which accompanies this distribution, and is available at
http://www.eclipse.org/legal/epl-v10.html

Contributors:
    IBM Corporation - initial API and implementation*/

package com.ibm.www.WebChatControl;

import org.apache.muse.ws.resource.impl.AbstractWsResourceCapability;
import javax.xml.namespace.QName;

public class MyCapability extends AbstractWsResourceCapability implements IMyCapability
{
	
	public MyCapability(){
		super();
		primInitialize();		
	}
	
    private static final QName[] _PROPERTIES = new QName[]
    {
        new QName(NAMESPACE_URI, "maxNumberOfUsers", PREFIX),
        new QName(NAMESPACE_URI, "currentNumberOfUsers", PREFIX)
    };

    public QName[] getPropertyNames()
    {
        return _PROPERTIES;
    }

    private int _maxNumberOfUsers = 5;

    private int _currentNumberOfUsers = 0;

    public int getMaxNumberOfUsers()
    {
        return _maxNumberOfUsers;
    }

    public void setMaxNumberOfUsers(int param0)
    {
        _maxNumberOfUsers = param0;
    }

    public int getCurrentNumberOfUsers()
    {
        return _currentNumberOfUsers;
    }

    public void setCurrentNumberOfUsers(int param0)
    {
        _currentNumberOfUsers = param0;
    }

    public boolean forceLogOff() throws Exception    {
        //TODO implement forceLogOff
    	setCurrentNumberOfUsers(0);
        System.out.println("all users have been logged off");
    	return true;
    }

    public int incrementMaxNumberOfUsers(int param0) throws Exception    {
        //TODO implement incrementMaxNumberOfUsers
        setMaxNumberOfUsers(getMaxNumberOfUsers()+param0);
        return getMaxNumberOfUsers();
    }

    public int decreaseMaxNumberOfUsers(int param0) throws Exception    {
        //TODO implement decreaseMaxNumberOfUsers
        
    	if ((getMaxNumberOfUsers()- param0)<0) {setMaxNumberOfUsers(0);			
		} else {setMaxNumberOfUsers(getMaxNumberOfUsers()-param0);
		}        
        return getMaxNumberOfUsers();
    }
    
    public int increaseMaxNumberOfUsers(int param0) throws Exception    {
        //TODO implement increaseMaxNumberOfUsers
        
    	setMaxNumberOfUsers(getMaxNumberOfUsers()+ param0);
        return getMaxNumberOfUsers();
    }
    
    
    protected void primInitialize() {
		// TODO Hook into the JMX MBeans here to initialize the app
    	//setup the initial number of users & max users
    	System.out.println("I've been initialized");
    }


}